#!/usr/bin/env python3

import yaml
from jinja2 import Environment, FileSystemLoader

def main():
    """ev15_index: builds a list of galleries based on index.yaml

    Usage: ev15_index"""
    
    build_html()

def build_html():
    f = open('index.yaml', 'r')
    site = yaml.load(f.read(), Loader=yaml.SafeLoader)
    f.close()

    # Set up jinja templates
    env = Environment(
        loader=FileSystemLoader('templates')
    )
    try:
        template = env.get_template('index.html')
    except TemplateSyntaxError:
        print("Problem with the template")
    
    # Write index.html
    f = open('index.html', 'w')
    f.write(template.render(title = site['title'],
                            name = site['name'], 
                            galleries = site['galleries']))
    f.close()


if __name__ == "__main__":
    main()